<?php

namespace Teknisa\MAN\Services;

use Teknisa\MAN\Utilities;
use Zeedhi\Framework\DataSource\DataSet; 
use Zeedhi\Framework\DTO;

class ParametroGerencial {   
	
	
	protected $entityManager;

	public function __construct(\Doctrine\ORM\EntityManager $entityManager, $connection)  {
	    $this->connection    = $connection;
		$this->entityManager = $entityManager;
	}
	
	public function deletarRegistrosGerais($informacoes) {
	    
	    $params = array(
            ':CDFILIAL'           => $informacoes['CDFILIAL'],
            ':CDLOJA'             => $informacoes['CDLOJA'],     
	    	':DTPERIODO'          => $informacoes['DTPERIODO'], 
	    	':NRORG'              => $informacoes['NRORG']
        );
		$this->entityManager->getConnection()->executeQuery(self::DELETAR_PARAMETRO_GERAL, $params);
		
	}
	
	public function deletarTodasReceitas($informacoes) {
	    
	    $params = array(
            ':CDFILIAL'           => $informacoes['CDFILIAL'],
            ':CDLOJA'             => $informacoes['CDLOJA'],     
	    	':DTPERIODO'          => $informacoes['DTPERIODO'], 
	    	':NRORG'              => $informacoes['NRORG']
        );
        
        try {
			$resposta = $this->entityManager->getConnection()->executeQuery(self::DELETAR_RECEITAS_TODOS, $params);        	
        } catch(\Exception $e){ 
        	$resposta = $e->getMessage();
        }
		//return $this->entityManager->getConnection()->executeQuery(self::DELETAR_RECEITAS_TODOS, $params);
		return $resposta;
	}
	
	public function deletarTodasDespesas($informacoes) {
	    
	    $params = array(
            ':CDFILIAL'           => $informacoes['CDFILIAL'],
            ':CDLOJA'             => $informacoes['CDLOJA'],     
	    	':DTPERIODO'          => $informacoes['DTPERIODO'], 
	    	':NRORG'              => $informacoes['NRORG']
        );
		$this->entityManager->getConnection()->executeQuery(self::DELETAR_DESPESAS_TODOS, $params);
	}
	
	public function inserirParametrosGerais($informacoes) {
	    $params = array(
            ':CDFILIAL'           => $informacoes['CDFILIAL'],
            ':CDLOJA'             => $informacoes['CDLOJA'],         
	    	':DTPERIODO'          => $informacoes['DTPERIODO'], 
	    	':VRSALARIOMENSAL'    => $informacoes['VRSALARIOMENSAL'],
	    	':VRPERCFIXMARKET'    => $informacoes['VRPERCFIXMARKET'],
	    	':VRPERCFIXROYALT'	  => $informacoes['VRPERCFIXROYALT'],
	    	':NRTOTALHORAS' 	  => $informacoes['NRTOTALHORAS'],
	    	':VRALUGUEL'	      => $informacoes['VRALUGUEL'],
	    	':VRCONDOMINIO'	      => $informacoes['VRCONDOMINIO'],
	    	':VRSEMITOTREAL'	  => $informacoes['VRSEMITOTREAL'],
	    	':VRBRUTVENDPROJ'     => $informacoes['VRBRUTVENDPROJ'], 
	    	':VRMENSALPROJ'       => $informacoes['VRMENSALPROJ'],
	    	':VRQTHORAPROJ'       => $informacoes['VRQTHORAPROJ'],
	    	':VRCUSTOHRPROJ'	  => $informacoes['VRCUSTOHRPROJ'],
	    	':VRPERCMARKPROJ' 	  => $informacoes['VRPERCMARKPROJ'],
	    	':VRPERCROYPROJ'	  => $informacoes['VRPERCROYPROJ'],
	    	':VRALUGUELPROJ'	  => $informacoes['VRALUGUELPROJ'],
	    	':VRCONDOMPROJ'	      => $informacoes['VRCONDOMPROJ'],
	    	':VRSEMITOTPROJ' 	  => $informacoes['VRSEMITOTPROJ'],
	    	':VRQTTRANSPROJ'	  => $informacoes['VRQTTRANSPROJ'],
	    	':VRQTCLIPROJ'	      => $informacoes['VRQTCLIPROJ'],
	    	':VRESTVALORIZADO'	  => $informacoes['VRESTVALORIZADO'],
	    	':VRFRETECAR'		  => $informacoes['VRFRETECAR'], 
	    	':VRFRETECARPROJ'     => $informacoes['VRFRETECARPROJ'], 
	    	':VRARMAZENA'		  => $informacoes['VRARMAZENA'], 
	    	':VRARMAZENAPROJ'     => $informacoes['VRARMAZENAPROJ'],   
	    	':NRORG'              => $informacoes['NRORG']
        );
		$return = $this->entityManager->getConnection()->executeQuery(self::INSERIR_PARAMETRO_GERAL, $params);
		return $return;
	}
	
	public function inserirDespesas($informacoes) {
	    $params = array(
            ':CDFILIAL'           => $informacoes['CDFILIAL'],
            ':CDLOJA'             => $informacoes['CDLOJA'],         
	    	':DTPERIODO'          => $informacoes['DTPERIODO'], 
	    	':CDTPCTPAGAR'        => str_pad($informacoes['CDTPCTPAGAR'], 6, "0", STR_PAD_LEFT),
	    	':VRCTPAGAR'          => $informacoes['VRCTPAGAR'],
	    	':IDUTILITIES'	      => $informacoes['IDUTILITIES'],
	    	':VRDESPESAPROJ' 	  => $informacoes['VRDESPESAPROJ'],
	    	':IDSUBTRAISEMIS'	  => $informacoes['IDSUBTRAISEMIS'],
	    	':NRORG'              => $informacoes['NRORG']
        );
		$return = $this->entityManager->getConnection()->executeQuery(self::INSERIR_DESPESAS, $params);
		return $return;
	}
	
	public function inserirReceitas($informacoes) {
	    $params = array(
            ':CDFILIAL'           => $informacoes['CDFILIAL'],
            ':CDLOJA'             => $informacoes['CDLOJA'],         
	    	':DTPERIODO'          => $informacoes['DTPERIODO'], 
	    	':CDTPCTRECEB'        => $informacoes['CDTPCTRECEB'],
	    	':VRCTRECEB'          => $informacoes['VRCTRECEB'],
	    	':VRRECEITAPROJ'	  => $informacoes['VRRECEITAPROJ'],
	    	':NRORG'              => $informacoes['NRORG']
        );
		$return = $this->entityManager->getConnection()->executeQuery(self::INSERIR_RECEITAS, $params);
		return $return;
	}
	
	public function deletarDespesas($informacoes) {
	    $params = array(
            ':CDFILIAL'           => $informacoes['CDFILIAL'],
            ':CDLOJA'             => $informacoes['CDLOJA'],     
	    	':DTPERIODO'          => $informacoes['DTPERIODO'], 
	    	':CDTPCTPAGAR'        => str_pad($informacoes['CDTPCTPAGAR'], 6, "0", STR_PAD_LEFT),
	    	':NRORG'              => $informacoes['NRORG']
        );
 		$return = $this->entityManager->getConnection()->executeQuery(self::DELETAR_DESPESAS, $params);
		return $return;
	}
	
	public function deletarReceitas($informacoes) {
	    
	    $params = array(
            ':CDFILIAL'           => $informacoes['CDFILIAL'],
            ':CDLOJA'             => $informacoes['CDLOJA'],     
	    	':DTPERIODO'          => $informacoes['DTPERIODO'], 
	    	':CDTPCTRECEB'        => $informacoes['CDTPCTRECEB'],
	    	':NRORG'              => $informacoes['NRORG']
        );
		$return = $this->entityManager->getConnection()->executeQuery(self::DELETAR_RECEITAS, $params);
		return $return;
	}
	
	public function recuperarUnidades ($nrorg) {
	    $params = array(
	    	':NRORG' => $nrorg
        );
		$return = $this->entityManager->getConnection()->fetchAll(self::SELECT_FILIAL, $params);
		$unidades = array();
		
		foreach ($return as $unidade){
			$unidades[] = $unidade['CDFILIAL'];
		}
		return $unidades;
	}
	
	public function recuperarLojas ($nrorg) {
	    $params = array(
	    	':NRORG' => $nrorg
        );
		$return = $this->entityManager->getConnection()->fetchAll(self::SELECT_LOJA, $params);
		$lojas = array();
		
		foreach ($return as $loja){
			$lojas[] = $loja['LOJA_FILIAL'];
		}
		return $lojas;
	}
	
	public function recuperarDespesas ($nrorg) {
	    $params = array(
	    	':NRORG' => $nrorg
        );
		$return = $this->entityManager->getConnection()->fetchAll(self::SELECT_DESPESAS, $params);
		$despesas = array();
		
		foreach ($return as $despesa){
			$despesas[] = $despesa['CDTPCTPAGAR'];
		}
		return $despesas;
	}
	
	public function recuperarReceitas ($nrorg) {
	    $params = array(
	    	':NRORG' => $nrorg
        );
		$return = $this->entityManager->getConnection()->fetchAll(self::SELECT_RECEITAS, $params);
		$receitas = array();
		
		foreach ($return as $receita){
			$receitas[] = $receita['CDTPCTRECEB'];
		}
		return $receitas;
	}
	
	const SELECT_RECEITAS = "
		SELECT CDTPCTRECEB FROM TIPOCTRECEBER WHERE NRORG = :NRORG
	";
	
	const SELECT_DESPESAS = "
		SELECT CDTPCTPAGAR FROM TIPOCTPAGAR WHERE NRORG = :NRORG
	";
	
	const SELECT_FILIAL = "
	    SELECT CDFILIAL FROM FILIAL WHERE NRORG = :NRORG
	";
	
	const SELECT_LOJA = "
		SELECT L.CDLOJA||'_'||L.CDFILIAL LOJA_FILIAL FROM LOJA L JOIN FILIAL F ON L.CDFILIAL =  F.CDFILIAL WHERE L.NRORG = :NRORG
	";
	
	const INSERIR_RECEITAS = "
	    INSERT INTO PARAMPLRECEITAS
		(CDFILIAL, CDLOJA, DTPERIODO, CDTPCTRECEB, VRCTRECEB, VRRECEITAPROJ, NRORG)
		VALUES
		(:CDFILIAL, :CDLOJA, :DTPERIODO, :CDTPCTRECEB, :VRCTRECEB, :VRRECEITAPROJ, :NRORG)
	";
	
	const INSERIR_DESPESAS = "
	    INSERT INTO PARAMPLDESPESAS
		(CDFILIAL, CDLOJA, DTPERIODO, CDTPCTPAGAR, VRCTPAGAR, IDUTILITIES, VRDESPESAPROJ, IDSUBTRAISEMIS, NRORG)
		VALUES
		(:CDFILIAL, :CDLOJA, :DTPERIODO, :CDTPCTPAGAR, :VRCTPAGAR, :IDUTILITIES, :VRDESPESAPROJ, :IDSUBTRAISEMIS, :NRORG)
	";
	
	const INSERIR_PARAMETRO_GERAL = "
	    INSERT INTO PARAMPLGERENCIA
		(CDFILIAL, CDLOJA, DTPERIODO, VRSALARIOMENSAL, VRPERCFIXMARKET, VRPERCFIXROYALT, NRTOTALHORAS,
		 VRALUGUEL, VRCONDOMINIO, VRSEMITOTREAL, VRBRUTVENDPROJ, VRMENSALPROJ,  VRQTHORAPROJ, VRCUSTOHRPROJ,
		 VRPERCMARKPROJ, VRPERCROYPROJ, VRALUGUELPROJ, VRCONDOMPROJ, VRSEMITOTPROJ, VRQTTRANSPROJ, VRQTCLIPROJ, VRESTVALORIZADO, 
		 VRFRETECAR, VRFRETECARPROJ, VRARMAZENA, VRARMAZENAPROJ, NRORG)
		VALUES
		(:CDFILIAL, :CDLOJA, :DTPERIODO, :VRSALARIOMENSAL, :VRPERCFIXMARKET, :VRPERCFIXROYALT, :NRTOTALHORAS,
		 :VRALUGUEL, :VRCONDOMINIO, :VRSEMITOTREAL, :VRBRUTVENDPROJ, :VRMENSALPROJ, :VRQTHORAPROJ, :VRCUSTOHRPROJ,
		 :VRPERCMARKPROJ, :VRPERCROYPROJ, :VRALUGUELPROJ, :VRCONDOMPROJ, :VRSEMITOTPROJ, :VRQTTRANSPROJ, :VRQTCLIPROJ, :VRESTVALORIZADO, 
		 :VRFRETECAR, :VRFRETECARPROJ, :VRARMAZENA, :VRARMAZENAPROJ, :NRORG)
	";
	
	  
    const DELETAR_PARAMETRO_GERAL = "
		DELETE FROM PARAMPLGERENCIA
        WHERE CDFILIAL = :CDFILIAL AND CDLOJA = :CDLOJA AND DTPERIODO= :DTPERIODO AND NRORG = :NRORG
	";
	
	const DELETAR_DESPESAS = "
		DELETE FROM PARAMPLDESPESAS
        WHERE CDFILIAL = :CDFILIAL AND CDLOJA = :CDLOJA AND DTPERIODO = :DTPERIODO AND CDTPCTPAGAR = :CDTPCTPAGAR AND NRORG = :NRORG
	";
	
	const DELETAR_RECEITAS = "
		DELETE FROM PARAMPLRECEITAS
        WHERE CDFILIAL = :CDFILIAL AND CDLOJA = :CDLOJA AND DTPERIODO = :DTPERIODO AND CDTPCTRECEB = :CDTPCTRECEB AND NRORG = :NRORG
	";
	
	const DELETAR_DESPESAS_TODOS = "
		DELETE FROM PARAMPLDESPESAS
        WHERE CDFILIAL = :CDFILIAL AND CDLOJA = :CDLOJA AND DTPERIODO = :DTPERIODO AND NRORG = :NRORG
	";
	
	const DELETAR_RECEITAS_TODOS = "DELETE FROM PARAMPLRECEITAS WHERE CDFILIAL = :CDFILIAL AND CDLOJA = :CDLOJA AND DTPERIODO = :DTPERIODO AND NRORG = :NRORG";

}
