<?php

namespace Teknisa\MAN\Services;

use Doctrine\ORM\EntityManager;
use Teknisa\MAN\Utilities;

class RelatoriosVendaProduto {

	public function __construct(EntityManager $entityManager) {
        $this->entityManager = $entityManager;
    }
    
    
    public function findAnalitico($conditions) {
        $params = array(
         	":CDFILIAL" => $conditions['CDFILIAL'],
         	":TCDFILIAL" => $conditions['TCDFILIAL'],
         	":CDCAIXA" => $conditions['CDCAIXA'],
         	":TCDCAIXA" => $conditions['TCDCAIXA'],
         	":DTVENDAINI" => $conditions['DTVENDAINI'],
         	":DTVENDAFIN" => $conditions['DTVENDAFIN'],
         	
         	":CDARVPRODF" => $conditions['CDARVPRODF'],
         	":CDARVPRODI" => $conditions['CDARVPRODI'],
         	":CDPRODLIST" => $conditions['CDPRODLIST'],
         	":PRODNIV" => $conditions['PRODNIV'],
         	":TCDPRODUTO" => $conditions['TCDPRODUTO'],
         	
         	":CDTIPOCONS" => $conditions['CDTIPOCONS'],
         	":TCDTIPOCONS" => $conditions['TCDTIPOCONS'],
         	":MODALIDADE" => $conditions['MODALIDADE'],

         	":NRORG" => $conditions['NRORG']
 		);
 		
 		return $this->entityManager->getConnection()->fetchAll(self::GET_VENDA_PERIODO_ANALITIC, $params);
    }
    
    public function findSintetico($conditions) {
        $params = array(
         	":CDFILIAL" => $conditions['CDFILIAL'],
         	":TCDFILIAL" => $conditions['TCDFILIAL'],
         	":CDCAIXA" => $conditions['CDCAIXA'],
         	":TCDCAIXA" => $conditions['TCDCAIXA'],
         	":DTVENDAINI" => $conditions['DTVENDAINI'],
         	":DTVENDAFIN" => $conditions['DTVENDAFIN'],
         
         	":CDARVPRODF" => $conditions['CDARVPRODF'],
         	":CDARVPRODI" => $conditions['CDARVPRODI'],
         	":CDPRODLIST" => $conditions['CDPRODLIST'],
         	":PRODNIV" => $conditions['PRODNIV'],
         	":TCDPRODUTO" => $conditions['TCDPRODUTO'],
         	
            ":CDTIPOCONS" => $conditions['CDTIPOCONS'],
         	":TCDTIPOCONS" => $conditions['TCDTIPOCONS'],
         	":MODALIDADE" => $conditions['MODALIDADE'],

         	":NRORG" => $conditions['NRORG']
 		);
 		return $this->entityManager->getConnection()->fetchAll(self::GET_VENDA_PERIODO_SINTETIC, $params);
    }
    
    public function findData($conditions) {
        
        $params = array(
            ":CDFILIAL" => $conditions['CDFILIAL'],
         	":TCDFILIAL" => $conditions['TCDFILIAL'],
         	":CDCAIXA" => $conditions['CDCAIXA'],
         	":TCDCAIXA" => $conditions['TCDCAIXA'],
         	":DTVENDAINI" => $conditions['DTVENDAINI'],
         	":DTVENDAFIN" => $conditions['DTVENDAFIN'],
         
         	":CDARVPRODF" => $conditions['CDARVPRODF'],
         	":CDARVPRODI" => $conditions['CDARVPRODI'],
         	":CDPRODLIST" => $conditions['CDPRODLIST'],
         	":PRODNIV" => $conditions['PRODNIV'],
         	":TCDPRODUTO" => $conditions['TCDPRODUTO'],
         	
         	":CDTIPOCONS" => $conditions['CDTIPOCONS'],
         	":TCDTIPOCONS" => $conditions['TCDTIPOCONS'],
         	":MODALIDADE" => $conditions['MODALIDADE'],
         	
         	":NRORG" => $conditions['NRORG']
        );
        
         	
        return $this->entityManager->getConnection()->fetchAll(self::GET_VENDA_PERIODO_DATA, $params);
    }
    
    public function buildParamsFaturamento($conditions, $modalidades){    
        $conditions['CDFILIAL'] = implode($conditions['CDFILIAL'], '_');
        $conditions['TCDFILIAL'] = 'E';
        if( array_key_exists('CDFILICAIXA', $conditions) ) {
            $conditions['CDCAIXA'] = implode($conditions['CDFILICAIXA'], '_');
            $conditions['TCDCAIXA'] = 'F';
            unset($conditions['CDFILICAIXA']);
        } else {
            $conditions['CDCAIXA'] = null;
            $conditions['TCDCAIXA'] = 'T';    
        }
        
        if( array_key_exists('CDTIPOCONS', $conditions) ) {
            $conditions['CDTIPOCONS'] = implode($conditions['CDTIPOCONS'], '_');
            $conditions['TCDTIPOCONS'] = 'F';
        } else {
            $conditions['CDTIPOCONS'] = null;
            $conditions['TCDTIPOCONS'] = 'T';    
        }
        
        if( array_key_exists('MODALIDADE', $conditions) ) {
            $conditions['MODALIDADE'] = implode($conditions['MODALIDADE'], '_');
        } else {
            $conditions['MODALIDADE'] = $modalidades;
        }
        
        if(array_key_exists('DTENTRVENDA', $conditions)) {
            $conditions['DTVENDAINI'] = $conditions['DTENTRVENDA'][0];
            $conditions['DTVENDAFIN'] = $conditions['DTENTRVENDA'][1];
            unset($conditions['DTENTRVENDA']);
        }
        if (isset($conditions['INTERVALISTA']) && $conditions['INTERVALISTA'] == 'I'){
           if (empty($conditions['CDARVPRODF'])){
                $conditions['CDARVPRODF'] = $conditions['CDARVPRODI'];
           }
           $conditions['TCDPRODUTO'] = null;
           $conditions['CDPRODLIST'] = null;
           $conditions['PRODNIV'] = null;
        }elseif (isset($conditions['INTERVALISTA']) && $conditions['INTERVALISTA'] == 'D') {
           $conditions['PRODNIV'] = str_replace('%', '', str_replace('.', '', $conditions['PRODNIV'])).'%';
           $conditions['TCDPRODUTO'] = null;
           $conditions['CDPRODLIST'] = null;
           $conditions['CDARVPRODF'] = null;
           $conditions['CDARVPRODI'] = null;
        }
        elseif (isset($conditions['INTERVALISTA']) && $conditions['INTERVALISTA'] == 'L'){
           $conditions['CDPRODLIST'] = implode('_', $conditions['CDPRODUTO']);
           $conditions['TCDPRODUTO'] = null;
           $conditions['CDARVPRODF'] = null;
           $conditions['CDARVPRODI'] = null;
           $conditions['PRODNIV'] = null;
        }
        else{
           $conditions['TCDPRODUTO'] = 'T';
           $conditions['CDPRODLIST'] = null;
           $conditions['CDARVPRODF'] = null;
           $conditions['CDARVPRODI'] = null;
           $conditions['PRODNIV'] = null;
        }
        
        return $conditions;
    }
    
    
    const GET_VENDA_PERIODO_ANALITIC = "
     SELECT ROUND((B.QTPRODVEND/
(
SELECT COUNT(V.NRSEQVENDA) AS MTCBASE
        FROM VENDA V 
        WHERE V.IDSITUVENDA = 'O' 
           AND V.DTENTRVENDA BETWEEN :DTVENDAINI AND :DTVENDAFIN
           AND V.NRORG = :NRORG
           AND V.CDFILIAL = B.CDFILIAL)*1000), 2) AS MTC, 
ROUND((B.TOTALVEND * 100/ (SUM(TOTALVEND) OVER (PARTITION BY CDFILIAL, NRORG))), 5) VRPORVENDA, SUM(TOTALVEND) OVER (PARTITION BY CDFILIAL, NRORG) TOTALPORDATA, B.* FROM (SELECT PR.CDPRODUTO, PR.CDARVPROD, FILOCAVE.CDFILIAL, FILOCAVE.CDFILIAL || ' - ' || FILOCAVE.NMFILIAL AS LABELFILIAL, PR.NMPRODUTO,
           SUM(TRUNC( IT.QTPRODVEND * (IT.VRUNITVEND + NVL( IT.VRUNITVENDCL, 0 ) ), 2 ) - NVL( IT.VRDESITVEND, 0 ) + NVL( IT.VRACRITVEND, 0 ) ) AS TOTALVEND,
           PR.SGUNIDADE, IT.VRUNITVEND, SUM(TRUNC( IT.QTPRODVEND * (IT.VRUNITVEND + NVL( IT.VRUNITVENDCL, 0 ) ), 2 ) ) AS VALORVENDIDO,
           SUM(IT.QTPRODVEND) AS QTPRODVEND, SUM(NVL( IT.VRDESITVEND, 0 ) ) AS VRDESITVEND, SUM(NVL( IT.VRACRITVEND, 0 ) ) AS ACRESCIMO,
           FILOCAVE.NRORG, FILOCAVE.CDPRODTAXAENTR,  FILOCAVE.IDORIGEMVENDA, FILOCAVE.MODALIDADE, FILOCAVE.CDTIPOCONS,  NVL(FILOCAVE.NMTIPOCONS, 'S/ CONSUMIDOR') AS NMTIPOCONS
      FROM ITEMVENDA IT
      JOIN PRODUTO PR 
        ON IT.CDPRODUTO = PR.CDPRODUTO
       AND IT.CDPRODUTO = PR.CDPRODUTO
      JOIN ( SELECT FILOCAVE.IDSITUVENDA, FILOCAVE.NRSEQVENDA, FILOCAVE.CDCAIXA, FILOCAVE.NMCAIXA, FILOCAVE.CDLOJA, FILOCAVE.NMLOJA, FILOCAVE.CDFILIAL, FILOCAVE.NMFILIAL,
                    FILOCAVE.NRORG, FILOCAVE.CDPRODTAXASERV, FILOCAVE.CDCONSUMIDOR, C.CDTIPOCONS, TC.NMTIPOCONS, FILOCAVE.IDORIGEMVENDA, FILOCAVE.CDPRODTAXAENTR, FILOCAVE.MODALIDADE
              FROM ( SELECT V.IDORIGEMVENDA, V.CDCLIENTE, V.CDCONSUMIDOR, V.IDSITUVENDA, V.NRSEQVENDA, FILOCA.CDCAIXA, FILOCA.NMCAIXA, FILOCA.CDLOJA, FILOCA.NMLOJA, FILOCA.CDFILIAL, FILOCA.NMFILIAL,
                            FILOCA.NRORG, FILOCA.CDPRODTAXASERV, FILOCA.CDPRODTAXAENTR,
                            CASE SUBSTR(V.IDORIGEMVENDA, 0, 3)
                                       WHEN 'DLV' THEN 'DELIVERY'
                                       WHEN 'MES' THEN 'MESA'
                                       WHEN 'BAL' THEN (CASE SUBSTR(V.IDORIGEMVENDA, 5, 7) WHEN 'AUT' THEN 'TERMINAL DE AUTO-ATENDIMENTO' ELSE 'BALCAO' END) 
                                       WHEN 'TAA' THEN 'TERMINAL DE AUTO-ATENDIMENTO'
                                       WHEN 'CMD' THEN 'COMANDA'
                                       WHEN 'AJU' THEN 'OUTROS'
                                       ELSE 'OUTROS'
                                     END AS MODALIDADE
                       FROM VENDA V
                       JOIN ( SELECT C.CDCAIXA, C.NMCAIXA, FILO.CDLOJA, FILO.NMLOJA, FILO.CDFILIAL, FILO.NMFILIAL, FILO.NRORG, FILO.CDPRODTAXASERV, FILO.CDPRODTAXAENTR
                                FROM CAIXA C 
                                JOIN ( SELECT L.CDLOJA, L.NMLOJA, FI.CDFILIAL, FI.NMFILIAL, FI.NRORG, L.CDPRODTAXASERV, L.CDPRODTAXAENTR
                                         FROM LOJA L 
                                         JOIN ( SELECT F.CDFILIAL, F.NMFILIAL, F.NRORG
                                                  FROM FILIAL F 
                                                 WHERE ( ( INSTR( :CDFILIAL, F.CDFILIAL ) <> 0 ) OR ( :TCDFILIAL = 'T' ) ) 
                                                   AND F.NRORG =:NRORG
                                              ) FI 
                                           ON L.CDFILIAL = FI.CDFILIAL
                                          AND L.NRORG = FI.NRORG
                                     ) FILO 
                                  ON C.CDFILIAL = FILO.CDFILIAL
                                 AND C.CDLOJA = FILO.CDLOJA
                                 AND C.NRORG = FILO.NRORG
                                 AND ( ( INSTR( :CDCAIXA, C.CDCAIXA ) <> 0 ) OR ( :TCDCAIXA = 'T' ) )
                             ) FILOCA 
                          ON V.CDCAIXA = FILOCA.CDCAIXA
                         AND V.CDLOJA = FILOCA.CDLOJA
                         AND V.CDFILIAL = FILOCA.CDFILIAL
                         AND V.NRORG = FILOCA.NRORG
                       WHERE V.IDSITUVENDA = 'O'
                         AND V.DTENTRVENDA BETWEEN :DTVENDAINI AND :DTVENDAFIN
                         AND (INSTR(:MODALIDADE, SUBSTR(V.IDORIGEMVENDA, 0, 3) ) > 0 OR INSTR(:MODALIDADE, SUBSTR(V.IDORIGEMVENDA, 5, 7) ) > 0)
                         AND V.IDSITUVENDA IN( CASE SUBSTR(V.IDORIGEMVENDA, 0, 3)
                                                 WHEN 'DLV' THEN 'O'
                                                 WHEN 'MES' THEN 'O'
                                                 WHEN 'BAL' THEN 'O'
                                                 WHEN 'TAA' THEN 'O'
                                                 WHEN 'CMD' THEN 'O'
                                                 WHEN 'AJU' THEN V.IDSITUVENDA
                                                END)                       
                   ) FILOCAVE 
              LEFT JOIN CONSUMIDOR C
                ON FILOCAVE.CDCONSUMIDOR = C.CDCONSUMIDOR 
               AND FILOCAVE.CDCLIENTE = C.CDCLIENTE
               AND FILOCAVE.NRORG = C.NRORG
              LEFT JOIN TIPOCONS TC
                ON C.CDTIPOCONS = TC.CDTIPOCONS
             WHERE ( ( INSTR( :CDTIPOCONS, C.CDTIPOCONS) <> 0 ) OR ( :TCDTIPOCONS = 'T' ) )
            ) FILOCAVE
        ON FILOCAVE.CDFILIAL = IT.CDFILIAL
       AND FILOCAVE.CDCAIXA = IT.CDCAIXA
       AND FILOCAVE.NRSEQVENDA = IT.NRSEQVENDA
       AND FILOCAVE.NRORG = IT.NRORG
     WHERE IT.CDPRODUTO <> NVL( FILOCAVE.CDPRODTAXASERV, 0 )
       AND IT.CDPRODUTO <> NVL( FILOCAVE.CDPRODTAXAENTR, 0 )
       AND (((((INSTR(:CDPRODLIST, PR.CDPRODUTO) > 0 ) OR (PR.CDARVPROD BETWEEN :CDARVPRODI AND :CDARVPRODF ))) OR (PR.CDARVPROD LIKE :PRODNIV)) OR (:TCDPRODUTO = 'T'))
     GROUP BY PR.CDPRODUTO, FILOCAVE.CDFILIAL, FILOCAVE.CDFILIAL, FILOCAVE.NMFILIAL, PR.CDARVPROD, 
              PR.SGUNIDADE, PR.NMPRODUTO, IT.VRUNITVEND, IT.VRUNITVENDCL, FILOCAVE.NRORG, 
              FILOCAVE.CDPRODTAXAENTR, FILOCAVE.IDORIGEMVENDA, FILOCAVE.MODALIDADE, FILOCAVE.CDTIPOCONS, FILOCAVE.NMTIPOCONS
     ORDER BY FILOCAVE.CDFILIAL, PR.CDARVPROD) B
     ";

    const GET_VENDA_PERIODO_SINTETIC = "
  SELECT ROUND((B.QTPRODVEND/
(
SELECT COUNT(V.NRSEQVENDA) AS MTCBASE
        FROM VENDA V 
        WHERE V.IDSITUVENDA = 'O' 
           AND V.DTENTRVENDA BETWEEN :DTVENDAINI AND :DTVENDAFIN
           AND V.NRORG = :NRORG
           AND ( ( INSTR( :CDFILIAL, V.CDFILIAL ) <> 0 ) OR ( :TCDFILIAL = 'T' ) ) )*1000), 2) AS MTC, 
ROUND((B.TOTALVEND * 100/ (SUM(TOTALVEND) OVER (PARTITION BY NRORG))), 5) VRPORVENDA, SUM(TOTALVEND) OVER (PARTITION BY NRORG) TOTALPORDATA, B.* FROM (SELECT PR.CDPRODUTO, PR.CDARVPROD, FILOCAVE.CDFILIAL, FILOCAVE.CDFILIAL || ' - ' || FILOCAVE.NMFILIAL AS LABELFILIAL, PR.NMPRODUTO,
           SUM(TRUNC( IT.QTPRODVEND * (IT.VRUNITVEND + NVL( IT.VRUNITVENDCL, 0 ) ), 2 ) - NVL( IT.VRDESITVEND, 0 ) + NVL( IT.VRACRITVEND, 0 ) ) AS TOTALVEND,
           PR.SGUNIDADE, IT.VRUNITVEND, SUM(TRUNC( IT.QTPRODVEND * (IT.VRUNITVEND + NVL( IT.VRUNITVENDCL, 0 ) ), 2 ) ) AS VALORVENDIDO,
           SUM(IT.QTPRODVEND) AS QTPRODVEND, SUM(NVL( IT.VRDESITVEND, 0 ) ) AS VRDESITVEND, SUM(NVL( IT.VRACRITVEND, 0 ) ) AS ACRESCIMO,
           FILOCAVE.NRORG,  FILOCAVE.CDPRODTAXAENTR,  FILOCAVE.IDORIGEMVENDA,  FILOCAVE.CDTIPOCONS, NVL(FILOCAVE.NMTIPOCONS, 'S/ CONSUMIDOR') AS NMTIPOCONS, FILOCAVE.MODALIDADE
      FROM ITEMVENDA IT
      JOIN PRODUTO PR 
        ON IT.CDPRODUTO = PR.CDPRODUTO
       AND IT.CDPRODUTO = PR.CDPRODUTO
      JOIN (SELECT FILOCAVE.IDSITUVENDA, FILOCAVE.NRSEQVENDA, FILOCAVE.CDCAIXA, FILOCAVE.NMCAIXA, FILOCAVE.CDLOJA, FILOCAVE.NMLOJA, FILOCAVE.CDFILIAL, FILOCAVE.NMFILIAL,
                    FILOCAVE.NRORG, FILOCAVE.CDPRODTAXASERV, FILOCAVE.CDCONSUMIDOR, C.CDTIPOCONS, TC.NMTIPOCONS, FILOCAVE.IDORIGEMVENDA, FILOCAVE.CDPRODTAXAENTR, FILOCAVE.MODALIDADE
              FROM ( SELECT V.IDORIGEMVENDA, V.CDCLIENTE, V.CDCONSUMIDOR, V.IDSITUVENDA, V.NRSEQVENDA, FILOCA.CDCAIXA, FILOCA.NMCAIXA, FILOCA.CDLOJA, FILOCA.NMLOJA, FILOCA.CDFILIAL, FILOCA.NMFILIAL,
                        FILOCA.NRORG, FILOCA.CDPRODTAXASERV, FILOCA.CDPRODTAXAENTR,
                        CASE SUBSTR(V.IDORIGEMVENDA, 0, 3)
                           WHEN 'DLV' THEN 'DELIVERY'
                           WHEN 'MES' THEN 'MESA'
                           WHEN 'BAL' THEN (CASE SUBSTR(V.IDORIGEMVENDA, 5, 7) WHEN 'AUT' THEN 'TERMINAL DE AUTO-ATENDIMENTO' ELSE 'BALCAO' END) 
                           WHEN 'TAA' THEN 'TERMINAL DE AUTO-ATENDIMENTO'
                           WHEN 'CMD' THEN 'COMANDA'
                           WHEN 'AJU' THEN 'OUTROS'
                           ELSE 'OUTROS'
                         END AS MODALIDADE
                   FROM VENDA V
                   JOIN ( SELECT C.CDCAIXA, C.NMCAIXA, FILO.CDLOJA, FILO.NMLOJA, FILO.CDFILIAL, FILO.NMFILIAL, FILO.NRORG, FILO.CDPRODTAXASERV, FILO.CDPRODTAXAENTR
                            FROM CAIXA C 
                            JOIN ( SELECT L.CDLOJA, L.NMLOJA, FI.CDFILIAL, FI.NMFILIAL, FI.NRORG, L.CDPRODTAXASERV, L.CDPRODTAXAENTR
                                     FROM LOJA L 
                                     JOIN ( SELECT F.CDFILIAL, F.NMFILIAL, F.NRORG
                                              FROM FILIAL F 
                                             WHERE ( ( INSTR( :CDFILIAL, F.CDFILIAL ) <> 0 ) OR ( :TCDFILIAL = 'T' ) ) 
                                               AND F.NRORG =:NRORG
                                          ) FI 
                                       ON L.CDFILIAL = FI.CDFILIAL
                                      AND L.NRORG = FI.NRORG
                                 ) FILO 
                              ON C.CDFILIAL = FILO.CDFILIAL
                             AND C.CDLOJA = FILO.CDLOJA
                             AND C.NRORG = FILO.NRORG
                             AND ( ( INSTR( :CDCAIXA, C.CDCAIXA ) <> 0 ) OR ( :TCDCAIXA = 'T' ) )
                         ) FILOCA 
                      ON V.CDCAIXA = FILOCA.CDCAIXA
                     AND V.CDLOJA = FILOCA.CDLOJA
                     AND V.CDFILIAL = FILOCA.CDFILIAL
                     AND V.NRORG = FILOCA.NRORG
                   WHERE V.IDSITUVENDA = 'O'
                     AND V.DTENTRVENDA BETWEEN :DTVENDAINI AND :DTVENDAFIN
                     AND (INSTR(:MODALIDADE, SUBSTR(V.IDORIGEMVENDA, 0, 3) ) > 0 OR INSTR(:MODALIDADE, SUBSTR(V.IDORIGEMVENDA, 5, 7) ) > 0)
                     AND V.IDSITUVENDA IN( CASE SUBSTR(V.IDORIGEMVENDA, 0, 3)
                                             WHEN 'DLV' THEN 'O'
                                             WHEN 'MES' THEN 'O'
                                             WHEN 'BAL' THEN 'O'
                                             WHEN 'TAA' THEN 'O'
                                             WHEN 'CMD' THEN 'O'
                                             WHEN 'AJU' THEN V.IDSITUVENDA
                                            END)
               ) FILOCAVE 
              LEFT JOIN CONSUMIDOR C
                ON FILOCAVE.CDCONSUMIDOR = C.CDCONSUMIDOR 
               AND FILOCAVE.CDCLIENTE = C.CDCLIENTE
               AND FILOCAVE.NRORG = C.NRORG
              LEFT JOIN TIPOCONS TC
                ON C.CDTIPOCONS = TC.CDTIPOCONS
             WHERE ( ( INSTR( :CDTIPOCONS, C.CDTIPOCONS) <> 0 ) OR ( :TCDTIPOCONS = 'T' ) )
            ) FILOCAVE
        ON FILOCAVE.CDFILIAL = IT.CDFILIAL
       AND FILOCAVE.CDCAIXA = IT.CDCAIXA
       AND FILOCAVE.NRSEQVENDA = IT.NRSEQVENDA
       AND FILOCAVE.NRORG = IT.NRORG
     WHERE IT.CDPRODUTO <> NVL( FILOCAVE.CDPRODTAXASERV, 0 )
       AND IT.CDPRODUTO <> NVL( FILOCAVE.CDPRODTAXAENTR, 0 )
       AND (((((INSTR(:CDPRODLIST, PR.CDPRODUTO) > 0 ) OR (PR.CDARVPROD BETWEEN :CDARVPRODI AND :CDARVPRODF ))) OR (PR.CDARVPROD LIKE :PRODNIV)) OR (:TCDPRODUTO = 'T'))
     GROUP BY PR.CDPRODUTO, PR.CDARVPROD, FILOCAVE.CDFILIAL, FILOCAVE.NMFILIAL, PR.NMPRODUTO,PR.SGUNIDADE, IT.VRUNITVEND,
              FILOCAVE.NRORG,  FILOCAVE.CDPRODTAXAENTR,  FILOCAVE.IDORIGEMVENDA,  FILOCAVE.CDTIPOCONS, FILOCAVE.NMTIPOCONS, FILOCAVE.MODALIDADE

     ORDER BY FILOCAVE.CDFILIAL, PR.CDARVPROD) B 
    ";
    
    const GET_VENDA_PERIODO_DATA = "
        SELECT ROUND((B.QTPRODVEND/
    (
    SELECT COUNT(V.NRSEQVENDA) AS MTCBASE
            FROM VENDA V 
            WHERE V.IDSITUVENDA = 'O' 
               AND V.DTENTRVENDA = B.DTENTRVENDA2
               AND V.NRORG = :NRORG
               AND V.CDFILIAL = B.CDFILIAL)*1000), 2) AS MTC, 
    ROUND((B.TOTALVEND * 100/ (SUM(TOTALVEND) OVER (PARTITION BY DTENTRVENDA2, CDFILIAL, NRORG))), 5) VRPORVENDA, SUM(TOTALVEND) OVER (PARTITION BY DTENTRVENDA2, CDFILIAL, NRORG) TOTALPORDATA, B.* FROM (SELECT FILOCAVE.DTENTRVENDA AS DTENTRVENDA2, PR.CDPRODUTO, PR.CDARVPROD, FILOCAVE.CDFILIAL, FILOCAVE.CDFILIAL || ' - ' || FILOCAVE.NMFILIAL AS LABELFILIAL, PR.NMPRODUTO,
               SUM(TRUNC( IT.QTPRODVEND * (IT.VRUNITVEND + NVL( IT.VRUNITVENDCL, 0 ) ), 2 ) - NVL( IT.VRDESITVEND, 0 ) + NVL( IT.VRACRITVEND, 0 ) ) AS TOTALVEND,
               PR.SGUNIDADE, IT.VRUNITVEND, SUM(TRUNC( IT.QTPRODVEND * (IT.VRUNITVEND + NVL( IT.VRUNITVENDCL, 0 ) ), 2 ) ) AS VALORVENDIDO,
               SUM(IT.QTPRODVEND) AS QTPRODVEND, SUM(NVL( IT.VRDESITVEND, 0 ) ) AS VRDESITVEND, SUM(NVL( IT.VRACRITVEND, 0 ) ) AS ACRESCIMO,
               FILOCAVE.NRORG, FILOCAVE.CDPRODTAXAENTR,  FILOCAVE.IDORIGEMVENDA,  FILOCAVE.CDTIPOCONS, FILOCAVE.MODALIDADE, NVL(FILOCAVE.NMTIPOCONS, 'S/ CONSUMIDOR') AS NMTIPOCONS
          FROM ITEMVENDA IT
          JOIN PRODUTO PR 
            ON IT.CDPRODUTO = PR.CDPRODUTO
           AND IT.CDPRODUTO = PR.CDPRODUTO
          JOIN ( SELECT FILOCAVE.DTENTRVENDA, FILOCAVE.IDSITUVENDA, FILOCAVE.NRSEQVENDA, FILOCAVE.CDCAIXA, FILOCAVE.NMCAIXA, FILOCAVE.CDLOJA, FILOCAVE.NMLOJA, FILOCAVE.CDFILIAL, FILOCAVE.NMFILIAL,
                    FILOCAVE.NRORG, FILOCAVE.CDPRODTAXASERV, FILOCAVE.CDCONSUMIDOR, C.CDTIPOCONS, TC.NMTIPOCONS, FILOCAVE.IDORIGEMVENDA, FILOCAVE.CDPRODTAXAENTR, FILOCAVE.MODALIDADE
                   FROM ( SELECT V.IDORIGEMVENDA, V.CDCLIENTE, V.CDCONSUMIDOR, V.DTENTRVENDA, V.IDSITUVENDA, V.NRSEQVENDA, FILOCA.CDCAIXA, FILOCA.NMCAIXA, FILOCA.CDLOJA, FILOCA.NMLOJA, FILOCA.CDFILIAL, FILOCA.NMFILIAL,
                            FILOCA.NRORG, FILOCA.CDPRODTAXASERV, FILOCA.CDPRODTAXAENTR,
                            CASE SUBSTR(V.IDORIGEMVENDA, 0, 3)
                              WHEN 'DLV' THEN 'DELIVERY'
                              WHEN 'MES' THEN 'MESA'
                              WHEN 'BAL' THEN (CASE SUBSTR(V.IDORIGEMVENDA, 5, 7) WHEN 'AUT' THEN 'TERMINAL DE AUTO-ATENDIMENTO' ELSE 'BALCAO' END) 
                              WHEN 'TAA' THEN 'TERMINAL DE AUTO-ATENDIMENTO'
                              WHEN 'CMD' THEN 'COMANDA'
                              WHEN 'AJU' THEN 'OUTROS'
                              ELSE 'OUTROS'
                            END AS MODALIDADE
                       FROM VENDA V
                       JOIN ( SELECT C.CDCAIXA, C.NMCAIXA, FILO.CDLOJA, FILO.NMLOJA, FILO.CDFILIAL, FILO.NMFILIAL, FILO.NRORG, FILO.CDPRODTAXASERV, FILO.CDPRODTAXAENTR
                                FROM CAIXA C 
                                JOIN ( SELECT L.CDLOJA, L.NMLOJA, FI.CDFILIAL, FI.NMFILIAL, FI.NRORG, L.CDPRODTAXASERV, L.CDPRODTAXAENTR
                                         FROM LOJA L 
                                         JOIN ( SELECT F.CDFILIAL, F.NMFILIAL, F.NRORG
                                                  FROM FILIAL F 
                                                 WHERE ( ( INSTR( :CDFILIAL, F.CDFILIAL ) <> 0 ) OR ( :TCDFILIAL = 'T' ) ) 
                                                   AND F.NRORG =:NRORG
                                              ) FI 
                                           ON L.CDFILIAL = FI.CDFILIAL
                                          AND L.NRORG = FI.NRORG
                                     ) FILO 
                                  ON C.CDFILIAL = FILO.CDFILIAL
                                 AND C.CDLOJA = FILO.CDLOJA
                                 AND C.NRORG = FILO.NRORG
                                 AND ( ( INSTR( :CDCAIXA, C.CDCAIXA ) <> 0 ) OR ( :TCDCAIXA = 'T' ) )
                             ) FILOCA 
                          ON V.CDCAIXA = FILOCA.CDCAIXA
                         AND V.CDLOJA = FILOCA.CDLOJA
                         AND V.CDFILIAL = FILOCA.CDFILIAL
                         AND V.NRORG = FILOCA.NRORG
                       WHERE V.IDSITUVENDA = 'O'
                         AND V.DTENTRVENDA BETWEEN :DTVENDAINI AND :DTVENDAFIN
                         AND (INSTR(:MODALIDADE, SUBSTR(V.IDORIGEMVENDA, 0, 3) ) > 0 OR INSTR(:MODALIDADE, SUBSTR(V.IDORIGEMVENDA, 5, 7) ) > 0)
                         AND V.IDSITUVENDA IN( CASE SUBSTR(V.IDORIGEMVENDA, 0, 3)
                                                 WHEN 'DLV' THEN 'O'
                                                 WHEN 'MES' THEN 'O'
                                                 WHEN 'BAL' THEN 'O'
                                                 WHEN 'TAA' THEN 'O'
                                                 WHEN 'CMD' THEN 'O'
                                                 WHEN 'AJU' THEN V.IDSITUVENDA
                                                END)
                        ) FILOCAVE 
                   LEFT JOIN CONSUMIDOR C
                    ON FILOCAVE.CDCONSUMIDOR = C.CDCONSUMIDOR 
                   AND FILOCAVE.CDCLIENTE = C.CDCLIENTE
                   AND FILOCAVE.NRORG = C.NRORG
                  LEFT JOIN TIPOCONS TC
                    ON C.CDTIPOCONS = TC.CDTIPOCONS
                 WHERE ( ( INSTR( :CDTIPOCONS, C.CDTIPOCONS) <> 0 ) OR ( :TCDTIPOCONS = 'T' ) )
            ) FILOCAVE
            ON FILOCAVE.CDFILIAL = IT.CDFILIAL
           AND FILOCAVE.CDCAIXA = IT.CDCAIXA
           AND FILOCAVE.NRSEQVENDA = IT.NRSEQVENDA
           AND FILOCAVE.NRORG = IT.NRORG
         WHERE IT.CDPRODUTO <> NVL( FILOCAVE.CDPRODTAXASERV, 0 )
           AND IT.CDPRODUTO <> NVL( FILOCAVE.CDPRODTAXAENTR, 0 )
           AND (((((INSTR(:CDPRODLIST, PR.CDPRODUTO) > 0 ) OR (PR.CDARVPROD BETWEEN :CDARVPRODI AND :CDARVPRODF ))) OR (PR.CDARVPROD LIKE :PRODNIV)) OR (:TCDPRODUTO = 'T'))
         GROUP BY FILOCAVE.DTENTRVENDA, PR.CDPRODUTO, FILOCAVE.CDFILIAL, FILOCAVE.CDFILIAL, FILOCAVE.NMFILIAL, PR.CDARVPROD, PR.SGUNIDADE, PR.NMPRODUTO, IT.VRUNITVEND, IT.VRUNITVENDCL, FILOCAVE.NRORG, FILOCAVE.CDPRODTAXAENTR,  FILOCAVE.IDORIGEMVENDA,  FILOCAVE.CDTIPOCONS, FILOCAVE.MODALIDADE, FILOCAVE.NMTIPOCONS
         ORDER BY FILOCAVE.DTENTRVENDA, FILOCAVE.CDFILIAL, PR.CDARVPROD) B  ORDER BY DTENTRVENDA2
    ";
}